(* 定数伝播 *)

open Global
open ILang

let find x env = try M.find x env with Not_found -> Var x
let find x env =
  match x with
  | Var x -> if x.Id.typ = Type.Tunit then Unit else find x env
  | _ -> x
let finds xs env = List.map (fun x -> find x env) xs

let rec g env e =
  match e with
  | Let(x,e1,e2) -> let e1_ = g env e1 in
    let env_ = match e1_ with
      | V y -> M.add x y env
      | _ -> env
    in
    Let(x, e1_, g env_ e2)
  | LetRec(x,ys,e1,e2) -> LetRec(x, ys, g env e1, g env e2)
  | If(c,x,y,e1,e2) -> If(c, find x env, find y env, g env e1, g env e2)
  | Op(x,ys) -> Op(find x env, finds ys env)
  | V x -> V(find x env)

let f e =
  gl_funs := List.map
    (fun func -> { func with body = g M.empty func.body })
    !gl_funs;
  g M.empty e
