(* 񤭽Ф *)

open Printf
open Global
open LinearAsm

let rec g oc e =
  if e == end_node then ()
  else begin
    if e.label != nolabel then fprintf oc "%s:\n" e.label;
    fprintf oc "\t%s\n" (str e.exp);
    g oc e.cont;
  end

let f oc xs =
  Hashtbl.iter (fun k vs ->
    fprintf oc "%s:\n" k;
    ignore(List.fold_left (fun i v ->
      fprintf oc "%s.%d:\n" k i;
      (match v with
      | ILang.Int i -> fprintf oc "\t.word 0x%x\n" i
      | ILang.Float a -> fprintf oc "\t.word 0x%lx\n" (f2b a)
      | ILang.Label l -> fprintf oc "\t.word %s\n" l
      | _ -> fprintf oc "\t.word 0\n");
      i+1) 0 vs))
    gl_vars;
  List.iter (fun x -> fprintf oc "%s:\n" x.fname; g oc x.entry) xs
