(* 変数名や関数名の型 *)

type t = {
  id : int;
  name : string;
  mutable typ : Type.t;
}

let compare x y = x.id - y.id
let hash x = x.id
let equal x y = x.id = y.id

let to_string { name = x; id = i } =
  x ^ "." ^ string_of_int i
let rec list_to_string lst =
  match lst with
  | [] -> ""
  | x::xs -> to_string x ^ " " ^ list_to_string xs

let new_id x = {
  name = x;
  typ = Type.new_type ();
  id = Shared.new_int ();
}

let new_id_t x t = {
  name = x;
  typ = t;
  id = Shared.new_int ();
}

let alpha x = { x with id = Shared.new_int () }

(* 使い道未定 *)
let special_id x = {
  name = x;
  typ = Type.new_type ();
  id = 0;
}

let special_id_t x t = {
  name = x;
  typ = t;
  id = 0;
}
