(* よーしパパインライン展開しちゃうぞー *)

open Global
open ILang

let threshold_min = 3 (* サイズがこれ以下の関数はインライン化 *)
let threshold = ref threshold_min
let envl = ref M2.empty

let inlinable name body =
  true
(*
  let rec is_rec e =
    match e with
    | V _ -> false
    | Op(x,_) -> x = name
    | If(_,_,_,e1,e2) | Let(_,e1,e2) -> is_rec e1 || is_rec e2
    | LetRec(_,_,_,e) -> is_rec e
  in
  not (is_rec body)
*)

let rec g thr env e =
  match e with
  | Op(Label x, ys) when M2.mem x !envl ->
      let (s, zs, body) = M2.find x !envl in
      if s <= max thr threshold_min
      then Alpha.g (M.add_list2 zs ys M.empty) body
      else e
  | Op(Var x, ys) when M.mem x env ->
      let (s, zs, body) = M.find x env in
      if s <= max thr threshold_min
      then Alpha.g (M.add_list2 zs ys M.empty) body
      else e
  | Let(x,e1,e2) -> Let(x, g thr env e1, g thr env e2)
  | LetRec(x,ys,e1,e2) ->
      let env_ =
        if inlinable (Var x) e1 then M.add x (size e1, ys, e1) env else env
      in
      LetRec(x, ys, g !threshold env_ e1, g thr env_ e2)
  | If(c,x,y,e1,e2) -> If(c,x,y, g (thr/2) env e1, g (thr/2) env e2)
  | _ -> e

let f e =
  let sfs = List.map (fun x -> size x.body, x) !gl_funs in
  let sfs = List.fast_sort (fun (x,_) (y,_) -> x - y) sfs in
  gl_funs := List.map snd sfs;
  envl := List.fold_left
      (fun m { name = x; args = ys; body = e } ->
        if inlinable (Label x) e then M2.add x (size e, ys, e) m else m)
      M2.empty !gl_funs;
  gl_funs := List.map
      (fun func -> let e = g !threshold M.empty func.body in
       envl := M2.add func.name (size e, func.args, e) !envl;
       { func with body = e })
      !gl_funs;
  g !threshold M.empty e
