(* Map + α *)

module Make (Elt : Map.OrderedType) = struct
  include Map.Make(Elt)

  let add_list xys m = List.fold_left (fun m (x, y) -> add x y m) m xys
  let add_list2 xs ys m = List.fold_left2 (fun m x y -> add x y m) m xs ys
  let remove_list xs m = List.fold_left (fun m x -> remove x m) m xs
  let filter p m = fold (fun k v m -> if p k v then m else remove k m) m m
  let inter m1 m2 = fold
    (fun k v m -> if mem k m && Elt.compare (find k m) v = 0
     then m else remove k m)
    m1 m2
end
