(* 同じ意味の式かどうかを近似的に判定する *)

open Id
open ILang

let rec eqv env x y =
  x = y ||
  match x,y with
  | Var x, Var y -> (try M.find x env = y with Not_found -> false)
  | _ -> false

let rec eq env e1 e2 =
  match e1,e2 with
  | V x, V y -> eqv env x y
  | Op(x,xs), Op(y,ys) ->
      eqv env x y &&
      (try List.for_all2 (eqv env) xs ys
       with Invalid_argument _ -> false)
  | Let(x,e1,e2), Let(y,e3,e4) -> eq env e1 e3 && eq (M.add x y env) e2 e4
  | LetRec(x,xs,e1,e2), LetRec(y,ys,e3,e4) ->
      let env_ = M.add x y env in
      x.typ = y.typ &&
      eq (M.add_list2 xs ys env_) e1 e3 &&
      eq env_ e2 e4
  | If(c1,x1,x2,e1,e2), If(c2,y1,y2,e3,e4) ->
      c1 = c2 &&
      eqv env x1 y1 &&
      eqv env x2 y2 &&
      eq env e1 e3 &&
      eq env e2 e4
  | _ -> false

let f e1 e2 = eq M.empty e1 e2
