(* 副作用のある関数を近似的に求める *)

open Builtin
open Global
open ILang

let result = ref S2.empty

let rec exists env e =
  match e with
  | V _ -> false
  | Op(Label l, _) ->
      List.mem l Builtin.side_effective_funs ||
      S2.mem l !result
  | Op(Var x, _) -> not (S.mem x env)
  | Op _ -> assert false
  | If(_,_,_,e1,e2) | Let(_,e1,e2) -> exists env e1 || exists env e2
  | LetRec(x,_,e1,e2) ->
      let env_ = S.add x env in
      exists (if exists env_ e1 then env else env_) e2

let rec g e =
  if List.fold_right (* callee の方から順に見る方が収束が速い *)
    (fun { name = x; body = e } modified ->
       if not (S2.mem x !result) && exists S.empty e
       then (result := S2.add x !result; true)
       else modified)
    !gl_funs false
  then g e else e

let f e =
  result := S2.empty;
  g e
