(* 構文の型 *)

type t =
| Unit
| Int of int
| Float of float
| Bool of bool
| Var of string
| Op of t * t list
| Tuple of t list (* 型推論の都合で特別扱い *)
| If of t * t * t
| Let of vdef * t
| LetRec of fdef * t
and vdef = string list * t (* let ((x,y),z) = ... とかはめんどいので略 :-p *)
and fdef = string * string list * t

type topdef =
| Defvar of vdef
| Defun of fdef
