(* 末尾でない分岐を末尾の分岐に変換 *)

open Global
open ILang

let threshold = ref 3

let h e =
  match e with
  | V _ | Op _ -> e
  | _ -> let name = Id.to_string (Id.new_id "hogefunc") in
    let args = S.elements (fv e) in
    gl_funs := { name = name; args = args; body = e } :: !gl_funs;
    Op(Label name, List.map (fun x -> Var x) args)

let rec g e =
  match e with
  | Let(x,If(c,y,z,e1,e2),e3) ->
      let e3_ = g e3 in
      if size e3_ <= !threshold then
        let x2 = Id.alpha x in
        If(c,y,z,
           Let(x, g e1, e3_),
           Let(x2, g e2, Alpha.g (M.add x (Var x2) M.empty) e3_))
      else begin match e3_ with
      | If(c2,y2,z2,e4,e5) -> (* 分岐先を別の関数にすれば小さくなるよ *)
          let x2 = Id.alpha x in
          let e3_ = If(c2,y2,z2, h e4, h e5) in
          If(c,y,z,
             Let(x, g e1, e3_),
             Let(x2, g e2, Alpha.g (M.add x (Var x2) M.empty) e3_))
      | _ -> Let(x,If(c,y,z, g e1, g e2), e3_)
      end
  | Let(x,e1,e2) -> Let(x, g e1, g e2)
  | LetRec(x,ys,e1,e2) -> LetRec(x,ys, g e1, g e2)
  | If(c,x,y,e1,e2) -> If(c,x,y, g e1, g e2)
  | _ -> e

let f e =
  let funs = !gl_funs in
  gl_funs := [];
  List.iter
    (fun func -> let f_ = { func with body = g func.body } in
     gl_funs := f_ :: !gl_funs)
    funs;
  g e
